#include "Picture.h"
#include<iostream>
#include<fstream>
#include<string>

using namespace std;

Picture::Picture(string fileName)
{
	ifstream fin(fileName, ios_base::binary);
	if (!fin.fail())
	{
		fin.read(fileHeader.headerField, 2);
		fin.read((char*)&fileHeader.size, 4);
		fin.read((char*)&fileHeader.reserved1, 2);
		fin.read((char*)&fileHeader.reserved2, 2);
		fin.read((char*)&fileHeader.pixelOffset, 4);

		fin.read((char*)&imageHeader.imageHeaderSize, 4);
		fin.read((char*)&imageHeader.width, 4);
		fin.read((char*)&imageHeader.height, 4);
		fin.read((char*)&imageHeader.colorPlanes, 2);
		fin.read((char*)&imageHeader.bitsPerPixel, 2);
		fin.read((char*)&imageHeader.compressionMethod, 4);
		fin.read((char*)&imageHeader.imageSize, 4);
		fin.read((char*)&imageHeader.horizontalResolution, 4);
		fin.read((char*)&imageHeader.verticalResolution, 4);
		fin.read((char*)&imageHeader.colorsInPalette, 4);
		fin.read((char*)&imageHeader.importantColors, 4);
	}
	else
	{
		cout << "Unable to find the file named " << fileName << endl;
	}
	fin.close();
}


Picture::~Picture()
{
	cout << "a picture object will die soon" << endl;
}

void Picture::display()
{
	fileHeader.display();
	imageHeader.display();
}


void FileHeader::display()
{
	cout << headerField[0] << headerField[1] << endl;
	cout << size << endl;
	cout << reserved1 << endl;
	cout << reserved2 << endl;
	cout << pixelOffset << endl;
}


void ImageHeader::display()
{
	cout << imageHeaderSize << endl;
	cout << width << endl;
	cout << height << endl;
	cout << colorPlanes << endl;//1
	cout << bitsPerPixel << endl; //24
	cout << compressionMethod << endl;
	cout << imageSize << endl;
	cout << horizontalResolution << endl;
	cout << verticalResolution << endl;
	cout << colorsInPalette << endl;
	cout << importantColors << endl;//0
}


